;;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
; Sequenced reponses to the Slave Poll, called so that the screen is updated.

Respond_SlavePoll:
	movf	MyId, 0				; Check it's the right ID
	subwf	Rad, 0
	btfss	STATUS, Z
	goto	ReceiveBreak			; Done, wait for next command

	clrf	Checksum 			; Clear checksum

	movf	Display, 0
	xorlw	0x01				; "Seeking --:-- "
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_1

	movf	Display, 0
	xorlw	0x02				; "Load"
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_2

	movf	Display, 0			; Play Time
	xorlw	0x03				;
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_3

	IFDEF	TRACKNAMES
	movf	Display, 0
	xorlw	0x04				; Track Name (1st)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_4

	IFDEF	LONGNAMES
	movf	Display, 0
	xorlw	0x05				; Track Name (2nd)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_5
	ENDIF	;<LONGNAMES>
	ENDIF	;<TRACKNAMES>

	movf	Display, 0
	xorlw	0x06				; Disc Name (1st)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_6

	IFDEF	LONGNAMES
	movf	Display, 0
	xorlw	0x07				; Disc Name (2nd)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_7
	ENDIF	;<LONGNAMES>

	goto	ReceiveBreak			; Stopper. should NEVER get here!!

;--------
Respond_SlavePoll_1:
	movlw	0x77				; 'Seeking CD'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xc0
	call	SendByte

	movlw	0x40
	call	SendByte

	call	Checksum_mid

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte
	
	movlw	0x00
	call	SendByte
	
	movf	TrackNum, 0			; Track Number
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

;;--					;;--  set DispCtrl
	swapf	DiskNum, 0			; Disk Number + disp code
	iorlw	0x0d
	call	SendByte
	
	call	Respond_End_R

;;-- Set DispCtrl --
;	movf	DisplayMode, 0
;	xorlw	Show_Time		;; = 0x09 (Track Time)
;	movlw	DispCtrl_DcName
;	btfsc	STATUS, Z
;	movwf	DispCtrl	
;
;	movf	DisplayMode, 0		;;
;	xorlw	Show_DcName		;; check  DisplayMode = DiscName
;	movlw	DispCtrl_DcName
;	btfsc	STATUS, Z
;	movwf	DispCtrl
;
;	movf	DisplayMode, 0		;;
;	xorlw	Show_TrName		;; check  DisplayMode = TrackName
;	movlw	DispCtrl_TrName
;	btfsc	STATUS, Z
;	movwf	DispCtrl
;--------
	movlw	0x02
	movwf	Display			; Next state: Display=2
	goto	IssueSlaveBreak
	

Respond_SlavePoll_2:
	movlw	0x70				; 'Seeking to Track'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xc0
	call	SendByte

	movlw	0x00
	call	SendByte

	call	Checksum_mid

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte
	
	movlw	0x00
	call	SendByte
	
	movf	TrackNum, 0			; Track Number
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte
;;--					;;--  set DispCtrl
	swapf	DiskNum, 0
;;	iorlw	0x0e					; Disk Number + disp code
	iorwf	DispCtrl, 0
	call	SendByte

	call	Respond_End_R

	movf	MyGroup, 0
	xorlw	0x30
	movlw	0x04			;; case MD, Next state: Display=4 (Track Name)
	btfsc	STATUS, Z
	movlw	0x06			;; case CD, Next state: Display=6 (Disc Name)
	movwf	Display			

	goto	IssueSlaveBreak


Respond_SlavePoll_3:
	movlw	0x70				; "CD d, Track t, mm:ss"
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0x90
	call	SendByte

	IFDEF	TRACKNAMES
	movlw	0x50
	ELSE
	movlw	0x00				;what's this??
	ENDIF	;;<TRACKNAMES>
	call	SendByte

	call	Checksum_mid

	movf	TrackNum, 0			; Track Number
	call	SendByte

	movf	Time1, 0			; Track Timer
	call	SendByte

	movf	Time0, 0			; Track Timer
	call	SendByte

	swapf	DiskNum, 0			; Disk Number + Disp code
	iorwf	DispCtrl, 0
	call	SendByte

	call	Respond_End_R

	goto	ReceiveBreak			; Wait until next event.


	IFDEF	TRACKNAMES
;;-----------------------------------
Respond_SlavePoll_4:
	movlw	0x70				; 'Track name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xC9
	call	SendByte

	IFDEF	PIC_16F62x
;;------------------------------
	movf	Track0, 0
	call	SendByte

	call	Checksum_mid

	movf	Track1, 0
	call	SendByte

	movf	Track2, 0
	call	SendByte

	movf	Track3, 0
	call	SendByte

	movf	Track4, 0
	call	SendByte
	
	movf	Track5, 0
	call	SendByte

	movf	Track6, 0
	call	SendByte

	movf	Track7, 0
	call	SendByte
;;------------------------------
	ENDIF	;;<PIC_16F62x>

	IFDEF	PIC_16F84
;;------------------------------
	movlw	Track0_def
	call	SendByte

	call	Checksum_mid

	movlw	Track1_def
	call	SendByte

	movlw	Track2_def
	call	SendByte

	movlw	Track3_def
	call	SendByte

	movlw	Track4_def
	call	SendByte
	
	movlw	Track5_def
	call	SendByte

	movlw	Track6_def
	call	SendByte

	movlw	Track7_def
	call	SendByte
;;------------------------------
	ENDIF	;;<PIC_16F84>

	IFDEF	PIC_12F683
;;------------------------------
	movlw	Track0_def
	call	SendByte

	call	Checksum_mid

	movlw	Track1_def
	call	SendByte

	movlw	Track2_def
	call	SendByte

	movlw	Track3_def
	call	SendByte

	movlw	Track4_def
	call	SendByte
	
	movlw	Track5_def
	call	SendByte

	movlw	Track6_def
	call	SendByte

	movlw	Track7_def
	call	SendByte
;;------------------------------
	ENDIF	;;<PIC_12F683>

	movlw	0x00
	call	SendByte

;;--					;;--  set DispCtrl
	movf	MyGroup, 0
	xorlw	0x30
	movlw	0x00			;; case MD, set field=0 -> W
	btfsc	STATUS, Z
	swapf	DiskNum, 0		;; case CD, set  Disk Number (swapped) -W
	iorwf	DispCtrl, 0
;;--
	call	SendByte

	call	Respond_End_R

	IFDEF	LONGNAMES
	movf	MyGroup, 0
	xorlw	0x30
	movlw	0x05			;; case MD, Next state: Display=5 (Track Name 2)
	btfsc	STATUS, Z
	movlw	0x06			;; case CD, Next state: Display=6 (Disc Name)
	movwf	Display	

	ELSE	;;<LONGNAMES>
	movlw	0x06			;; case CD/MD, Next state: Display=6 (Disc Name)
	movwf	Display	

	ENDIF	;;<LONGNAMES>

	goto	IssueSlaveBreak
;;---------------------------------
	ENDIF	;;<TRACKNAMES>
	

	IFDEF	TRACKNAMES
	IFDEF	LONGNAMES
;;----------------------------------
Respond_SlavePoll_5:

	movlw	0x70				; 'Track name, part2' (MD only)
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xC9
	call	SendByte

	movf	Track8, 0
	call	SendByte

	call	Checksum_mid

	movf	Track9, 0
	call	SendByte

	movf	TrackA, 0
	call	SendByte

	movf	TrackB, 0
	call	SendByte

	movf	TrackC, 0
	call	SendByte
	
	movf	TrackD, 0
	call	SendByte

	movf	TrackE, 0
	call	SendByte

	movf	TrackF, 0
	call	SendByte

	movlw	0x00
	call	SendByte
;;--
	movlw	0x10				; field 1
	iorwf	DispCtrl, 0
	call	SendByte

	call	Respond_End_R

	movlw	0x06			;; 	Next state: Display=6 (Disc Name)
	movwf	Display	

	goto	IssueSlaveBreak
;;----------------------------------------
	ENDIF	;<LONGNAMES>
	ENDIF	;<TRACKNAMES>


Respond_SlavePoll_6:
	movlw	0x70				; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xCD
	call	SendByte

	IFDEF	PIC_16F62x
;;------------------------------
	movf	Disk0, 0
	call	SendByte

	call	Checksum_mid

	movf	Disk1, 0
	call	SendByte

	movf	Disk2, 0
	call	SendByte

	movf	Disk3, 0
	call	SendByte

	movf	Disk4, 0
	call	SendByte
	
	movf	Disk5, 0
	call	SendByte

	movf	Disk6, 0
	call	SendByte

	movf	Disk7, 0
	call	SendByte
;;------------------------------
	ENDIF	;;<PIC_16F62x>

	IFDEF	PIC_16F84
;;------------------------------
	movlw	Disk0_def
	call	SendByte

	call	Checksum_mid

	movlw	Disk1_def
	call	SendByte

	movlw	Disk2_def
	call	SendByte

	movlw	Disk3_def
	call	SendByte

	movlw	Disk4_def
	call	SendByte
	
	movlw	Disk5_def
	call	SendByte

	movlw	Disk6_def
	call	SendByte

	movlw	Disk7_def
	call	SendByte
;;------------------------------
	ENDIF	;;<PIC_16F84>

	IFDEF	PIC_12F683
;;------------------------------
	movlw	Disk0_def
	call	SendByte

	call	Checksum_mid

	movlw	Disk1_def
	call	SendByte

	movlw	Disk2_def
	call	SendByte

	movlw	Disk3_def
	call	SendByte

	movlw	Disk4_def
	call	SendByte
	
	movlw	Disk5_def
	call	SendByte

	movlw	Disk6_def
	call	SendByte

	movlw	Disk7_def
	call	SendByte
;;------------------------------
	ENDIF	;;<PIC_12F683>

	movlw	0x00
	call	SendByte

;;--					;;--  set DispCtrl
	movf	MyGroup, 0
	xorlw	0x30
	movlw	0x00			;; case MD, set field=0 -> W
	btfsc	STATUS, Z
	swapf	DiskNum, 0		;; case CD, set  Disk Number (swapped) -W
	iorwf	DispCtrl, 0
;;--
	call	SendByte

	call	Respond_End_R

	IFDEF	LONGNAMES
	movf	MyGroup, 0
	xorlw	0x30
	movlw	0x07			;; case MD, Next state: Display=7 (Disc Name 2)
	btfsc	STATUS, Z
	ENDIF	
	movlw	0x03			;; case CD, Next state: Display=3 (Disc Name)
	movwf	Display

	IFDEF	SERIAL
;;---------------------------
	call	ClearRCREGs
;;---------------------------
	ENDIF	;;<SERIAL>

	goto	IssueSlaveBreak


	IFDEF	LONGNAMES
;;----------------------------------------------
Respond_SlavePoll_7:
	movlw	0x70				; 'CD name, part 2'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xCD
	call	SendByte

	movf	Disk8, 0
	call	SendByte

	call	Checksum_mid

	movf	Disk9, 0
	call	SendByte

	movf	DiskA, 0
	call	SendByte

	movf	DiskB, 0
	call	SendByte

	movf	DiskC, 0
	call	SendByte
	
	movf	DiskD, 0
	call	SendByte

	movf	DiskE, 0
	call	SendByte

	movf	DiskF, 0
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x10				; field 0
	iorwf	DispCtrl, 0
	call	SendByte

	call	Respond_End_R

	IFDEF	SERIAL
;;---------------------------
	call	ClearRCREGs
;;---------------------------
	ENDIF

	movlw	0x03			;; Next state: Display=3 (Disc Name)
	movwf	Display

	goto	IssueSlaveBreak
;;----------------------------------------------
	ENDIF	;;<LONGNAMES>



Respond_End_R:				;;-call/return type "Respond_End"
	movf	Checksum, 0			; Send Checksum
	call	SendByte
	movlw	0x00
	call	SendByte
	return

Checksum_mid:
	movf	Checksum, 0
	movwf	Count2
	movf	Checksum, 0
	call	SendByte
	movf	Count2, 0
	movwf	Checksum
	return


ClearRCREGs:
	IFDEF	SERIAL_INPUT
;;---------------------------------------
	movf	RCREG, 0			; clear RX buffer
	movf	RCREG, 0
	movf	RCREG, 0
	clrf	PIR1			;; clear PIR status
	bcf	RCSTA, CREN			; clear overflow
	bsf	RCSTA, CREN
	bsf	STATUS, RP0			; Select BANK1
	bsf	PIE1, RCIE			; enable RX interrupt
	bcf	STATUS, RP0			; Select BANK0
	clrf	RXState			;; clear RXState
;;---------------------------------------
	ENDIF	SERIAL_INPUT
	return


;;----- End of display.asm





